## magics++ 3.3.1

=== CMakeLists.txt ===
############################################################################################
# cmake options:
#
#       -DCMAKE_BUILD_TYPE=Debug|RelWithDebInfo|Release|Production
#
#       -DCMAKE_MODULE_PATH=/path/to/ecbuild/cmake
#
#       -DCMAKE_C_COMPILER=gcc
#
#       -DCMAKE_PREFIX_PATH=/path/to/jasper:/path/to/any/package/out/of/place
#

cmake_minimum_required( VERSION 3.1.0 FATAL_ERROR )

project( magics CXX )

# make sure that the header files are installed into include/magics
# note that this needs to be done before ecbuild_declare_project()
# to ensure that the ecbuild header files are also put there
# note also that we need to CACHE this so that ecbuild_declare_project() does not overwrite it
set(INSTALL_INCLUDE_DIR include/magics CACHE PATH "Magics installation directory for header files")

set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild/cmake")

include(ecbuild_system NO_POLICY_SCOPE)

ecbuild_requires_macro_version( 2.9 )

set (CMAKE_CXX_STANDARD 14)
set (CMAKE_C_STANDARD 99)

###############################################################################
# some variables of this project

ecbuild_use_package( PROJECT eccodes VERSION 2.9.2 REQUIRED
                     FAILURE_MSG "ecCodes is required in order to build Magics. Note that GRIB_API is no longer supported in Magics" )

set( grib_handling_pkg eccodes )
set( HAVE_GRIB 1 )
set( HAVE_BUFR 1 )


ecbuild_add_option( FEATURE ODB
                    DEFAULT OFF
                    DESCRIPTION "ODB support"
                    REQUIRED_PACKAGES "PROJECT odb_api VERSION 0.10.2")
					#	"PROJECT eckit   VERSION 0.9.0" )

#ecbuild_add_option( FEATURE CAIRO
#                    DEFAULT ON
#                    DESCRIPTION "cairo support[png/jpeg]"
#                    REQUIRED_PACKAGES PangoCairo)

option( ENABLE_CAIRO "cairo support[png/jpeg]" ON )
if( ENABLE_CAIRO )
  find_package(PangoCairo REQUIRED)
  if( NOT PANGOCAIRO_FOUND)
    message(FATAL_ERROR "Cairo support (PNG & PDF output) requested, but requirements were not found - can be disabled with -DENABLE_CAIRO=OFF")
  endif()
  set(HAVE_CAIRO ON)
  ecbuild_enable_feature( CAIRO )
else()
  ecbuild_disable_feature( CAIRO )
endif()

ecbuild_add_option( FEATURE GEOTIFF
                    DEFAULT OFF
                    DESCRIPTION "geotiff support [implies cairo]"
                    CONDITION HAVE_CAIRO
                    REQUIRED_PACKAGES GeoTIFF )

ecbuild_add_option( FEATURE NETCDF
                    DEFAULT ON
                    DESCRIPTION "enable netcdf support"
                    REQUIRED_PACKAGES "NetCDF 4 COMPONENTS C" )

ecbuild_add_option( FEATURE SPOT
                    DEFAULT OFF
                    DESCRIPTION "enable spot support"
                    REQUIRED_PACKAGES "PROJECT spot" )

find_package(PythonInterp REQUIRED)
find_package(Jinja2 REQUIRED)

ecbuild_add_option( FEATURE PYTHON
                    DEFAULT ON
                    DESCRIPTION "enable python interface"
                    REQUIRED_PACKAGES "Python NO_LIBS" NumPy )

ecbuild_add_option( FEATURE FORTRAN
                    DEFAULT ON
                    DESCRIPTION "enable Fortran interface" )

if( HAVE_FORTRAN )
	ecbuild_enable_fortran( REQUIRED )
endif()

ecbuild_add_option( FEATURE METVIEW
                    DEFAULT OFF
                    DESCRIPTION "enable Metview interface" )

ecbuild_add_option( FEATURE METVIEW_NO_QT
                    DEFAULT OFF
                    DESCRIPTION "enable Metview interface without Qt" )

option( BUILD_SHARED_LIBS  "Set to BOTH to build static library in addition to shared"  ON )
option( ENABLE_REGRESSION        "Internal use only: enable regression test"  OFF  )
option( ENABLE_REGRESSION_UPLOAD "Internal use only : enable upload of reference image"  OFF  )

set( MAGICS_NAME          "Magics" )
set( MAGICS_EXCEPTION     "ON" )
set( MAGICS_SITE          "ecmwf" )
set( MAGICS_INSTALL_PATH  ${CMAKE_INSTALL_PREFIX} )

set( MAGICS_REFERENCE_VERSIONS            "3.2.0" )
set( MAGICS_HTML_ROOT        "${CMAKE_BINARY_DIR}/regression/html")
file(MAKE_DIRECTORY ${MAGICS_HTML_ROOT} )

set( MAG_PYTHON_PATH ${CMAKE_CURRENT_BINARY_DIR}/python )

###############################################################################
# projects

### Metview and Qt
ecbuild_info("TESTING for Metview and Qt ...")

if(HAVE_METVIEW AND HAVE_METVIEW_NO_QT)
    ecbuild_critical("Do not set both HAVE_METVIEW and HAVE_METVIEW_NO_QT - only set one. You may have to remove your CMakeCache.txt to clear these settings.")
endif()

set( qt no )
set( metview no )

if( HAVE_METVIEW_NO_QT )
	set( metview yes )
	unset(MAGICS_ONLY)
endif()

if( HAVE_METVIEW )
    set ( metview yes)
    ecbuild_info("TESTING for Qt5 ...")
    unset(MAGICS_ONLY)

    find_package(Qt5Widgets REQUIRED)
    if( Qt5Widgets_FOUND )
        ecbuild_info("Qt5 was found ... ${Qt5Widgets_VERSION_STRING}")
        include_directories(${Qt5Widgets_INCLUDE_DIRS})
        set( MAGICS_QT 1)
        set( MAGICS_QT5 1)
        set( qt yes)
        add_definitions( -DMAGICS_QT5 )
    else()
        ecbuild_critical("Qt5 was NOT found, but it is necessary if METVIEW is enabled ...")
    endif()
endif()

ecbuild_declare_project()

###############################################################################
# find extra packages

set( CMAKE_THREAD_PREFER_PTHREAD 1 )
find_package( Threads )

find_package( Boost 1.53.0 REQUIRED)
find_package( Proj4 REQUIRED )
find_package( EXPAT REQUIRED )

###############################################################################
# contents

set( MAGICS_TPLS eccodes spot EXPAT NetCDF Proj4 )

set( MAGICS_INCLUDE_DIRS
     ${CMAKE_CURRENT_BINARY_DIR}/src
     ${CMAKE_CURRENT_BINARY_DIR}/src/params
     ${CMAKE_CURRENT_SOURCE_DIR}/src
     ${CMAKE_CURRENT_SOURCE_DIR}/src/common
     ${CMAKE_CURRENT_SOURCE_DIR}/src/basic
     ${CMAKE_CURRENT_SOURCE_DIR}/src/clipper
     ${CMAKE_CURRENT_SOURCE_DIR}/src/web
     ${CMAKE_CURRENT_SOURCE_DIR}/src/visualisers
     ${CMAKE_CURRENT_SOURCE_DIR}/src/drivers
     ${CMAKE_CURRENT_SOURCE_DIR}/src/drivers/MgQ
     ${CMAKE_CURRENT_SOURCE_DIR}/src/eckit_readers
     ${CMAKE_CURRENT_SOURCE_DIR}/src/decoders
     ${CMAKE_CURRENT_SOURCE_DIR}/src/terralib/kernel
     ${CMAKE_CURRENT_SOURCE_DIR}/src/libMagWrapper
     ${Boost_INCLUDE_DIRS} )

if( HAVE_CAIRO )
  list( APPEND MAGICS_TPLS PangoCairo)
  list( APPEND MAGICS_INCLUDE_DIRS ${PANGOCAIRO_INCLUDE_DIRS})
endif()

if( HAVE_ODB )
  list( APPEND MAGICS_TPLS odb_api )
  list( APPEND MAGICS_INCLUDE_DIRS
        ${CMAKE_CURRENT_SOURCE_DIR}/src/oda
        ${ODB_API_INCLUDE_DIRS}
		${ECKIT_INCLUDE_DIRS} )
endif()

set( MAGICS_LIBRARIES MagPlus )

foreach( _tpl ${MAGICS_TPLS} )
    string( TOUPPER ${_tpl} TPL )
    list( APPEND MAGICS_EXTRA_DEFINITIONS ${${TPL}_DEFINITIONS}  )
    list( APPEND MAGICS_EXTRA_INCLUDE_DIRS ${${TPL}_INCLUDE_DIRS} )
    string(REGEX REPLACE "[ ]+$" "" ${TPL}_LIBRARIES "${${TPL}_LIBRARIES}") # strips leading whitespaces
    string(REGEX REPLACE "^[ ]+" "" ${TPL}_LIBRARIES "${${TPL}_LIBRARIES}") # strips trailing whitespaces
    list( APPEND MAGICS_EXTRA_LIBRARIES ${${TPL}_LIBRARIES} )
    ecbuild_info("${TPL}_LIBRARIES [${${TPL}_LIBRARIES}]") # add this to confirm that indeed it was cleaned up
endforeach()


if( MAGICS_QT )
  list( APPEND MAGICS_EXTRA_INCLUDE_DIRS  ${Qt5Widgets_INCLUDE_DIR} )
  list( APPEND MAGICS_EXTRA_LIBRARIES     ${Qt5Widgets_LIBRARIES} )

  if( WITH_QT_DEBUG )
    list( APPEND MAGICS_EXTRA_DEFINITIONS QT_NO_DEBUG_OUTPUT )
  endif()
endif()

if( HAVE_GEOTIFF )
	list( APPEND MAGICS_EXTRA_INCLUDE_DIRS  ${GEOTIFF_INCLUDE_DIR} )
	list( APPEND MAGICS_EXTRA_LIBRARIES  ${GEOTIFF_LIBRARY} )
  list( APPEND MAGICS_EXTRA_DEFINITIONS HAVE_GEOTIFF )
endif()

list( APPEND MAGICS_EXTRA_LIBRARIES     ${CMAKE_THREAD_LIBS_INIT} )

ecbuild_debug("MAGICS_EXTRA_DEFINITIONS  => ${MAGICS_EXTRA_DEFINITIONS}")
ecbuild_debug("MAGICS_EXTRA_INCLUDE_DIRS => ${MAGICS_EXTRA_INCLUDE_DIRS}")
ecbuild_debug("MAGICS_EXTRA_LIBRARIES    => ${MAGICS_EXTRA_LIBRARIES}")

# set_directory_properties( PROPERTIES COMPILE_DEFINITIONS "${ECKIT_DEFINITIONS}" )
get_directory_property( MAGICS_DEFINITIONS COMPILE_DEFINITIONS )

include_directories( ${MAGICS_INCLUDE_DIRS} ${MAGICS_EXTRA_INCLUDE_DIRS} )


add_subdirectory( tools )
add_subdirectory( src )
add_subdirectory( share )
add_subdirectory( python )
add_subdirectory( apps )
add_subdirectory( test )
if( ENABLE_REGRESSION )
    add_subdirectory( regression )
endif()

# Directories not need in the distribution tar ball!
ecbuild_add_resources( TARGET old_src DONT_PACK_DIRS src/MvObs src/libTable src/xml src/terralib/functions)
ecbuild_add_resources( TARGET bamboo DONT_PACK_DIRS bamboo)
ecbuild_add_resources( TARGET old_ressources
		DONT_PACK_DIRS tools/versioncmp
		tools/regression
		regression
		docs
		toolsjs
		notebook
		test/old
		tools/xml
		tools/use_scripts
		tools/versioncmp_folders)

ecbuild_add_resources( TARGET notebook
    DONT_PACK_DIRS notebook )

ecbuild_add_resources( TARGET internal
		DONT_PACK configure.lxab
		configure.local
		configure.ecgb
		configure.ecmwf
)

############################################################################################
# finalize

set( MAGICS_DESCRIPTION "Multi-platform meteorological graphics library" )
set( MAGICS_URL "https://software.ecmwf.int/magics" )

ecbuild_pkgconfig()

ecbuild_install_project( NAME Magics )

ecbuild_print_summary()

=== src/CMakeLists.txt ===
###############################################################################

configure_file( magics_config.h.in  magics_config.h  )

install ( FILES ${CMAKE_CURRENT_BINARY_DIR}/magics_config.h  DESTINATION ${INSTALL_INCLUDE_DIR})

###############################################################################


function( add_metview_definition_file )

    set( single_value_args ACTION BASENAME FILE )
    cmake_parse_arguments( _p "${options}" "${single_value_args}" "${multi_value_args}"  ${_FIRST_ARG} ${ARGN} )

    add_custom_command(
            OUTPUT ${_p_BASENAME}Def ${_p_BASENAME}Rules
            COMMAND ${PYTHON_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/../../tools/xml2mv.py ${CMAKE_CURRENT_SOURCE_DIR} ${_p_FILE}  ${_p_BASENAME}Def ${_p_ACTION} ${_p_BASENAME}Rules
            DEPENDS ${_p_FILE}
      )


    add_custom_target( ${_p_BASENAME} ALL DEPENDS ${_p_BASENAME}Def)
    install ( FILES ${CMAKE_CURRENT_BINARY_DIR}/${_p_BASENAME}Def ${CMAKE_CURRENT_BINARY_DIR}/${_p_BASENAME}Rules DESTINATION ${INSTALL_DATA_DIR}/../magics/metview)

endfunction(add_metview_definition_file)

add_subdirectory( params )



foreach( file ${magics_xmls} )

      get_filename_component( path     ${file} PATH   )
      get_filename_component( basefile ${file} NAME_WE )

      set( ouputfiles ${path}/${basefile}Attributes.h ${path}/${basefile}Attributes.cc )

      # generate the code
      add_custom_command(
            OUTPUT  ${ouputfiles}
            COMMAND ${PYTHON_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/../tools/xml2cc.py ${CMAKE_CURRENT_SOURCE_DIR}/../tools/ ${CMAKE_CURRENT_SOURCE_DIR}/${file} ${CMAKE_CURRENT_BINARY_DIR}/params nosubdir
            DEPENDS ${file}
      )

      set_source_files_properties( ${basefile}Attributes.h  GENERATED )
      set_source_files_properties( ${basefile}Attributes.cc GENERATED )

      list( APPEND magics_params_srcs ${ouputfiles} )

endforeach()

if ( metview )

	foreach( file ${metview_xmls} )
	      get_filename_component( path     ${file} PATH   )
          get_filename_component( basefile ${file} NAME_WE )

		  set( metviewfiles ${path}/${basefile}Wrapper.h ${path}/${basefile}Wrapper.cc )


		# generate the code
		  add_custom_command(
				OUTPUT  ${metviewfiles}
                COMMAND ${PYTHON_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/../tools/xml2cc_mv.py ${CMAKE_CURRENT_SOURCE_DIR}/../tools/ ${CMAKE_CURRENT_SOURCE_DIR}/${file} ${CMAKE_CURRENT_BINARY_DIR}/params nosubdir
				DEPENDS ${file}
			)

		  set_source_files_properties( ${basefile}Wrapper.h  GENERATED )
          set_source_files_properties( ${basefile}Wrapper.cc GENERATED )
          list( APPEND metview_wrappers_srcs ${metviewfiles} )
      endforeach()

     if(qt)
        SET(qt_drivers_HEADERS drivers/MgQ/MgQPlotScene.h)
        if( MAGICS_QT5 )
          QT5_WRAP_CPP(qt_drivers_HEADERS_MOC ${qt_drivers_HEADERS})
        else()
          QT4_WRAP_CPP(qt_drivers_HEADERS_MOC ${qt_drivers_HEADERS})
        endif()
        list( APPEND drivers_srcs  drivers/MgQ/MgQPlotScene.cc  ${qt_drivers_HEADERS_MOC})
     endif()
endif()


add_custom_target( magics_params DEPENDS ${magics_params_srcs} )
add_custom_target( mv_params DEPENDS ${metview_wrappers_srcs} )
###############################################################################

add_subdirectory( common )
add_subdirectory( basic )
add_subdirectory( web )
add_subdirectory( visualisers )
add_subdirectory( drivers )
add_subdirectory( decoders )
add_subdirectory( terralib )
add_subdirectory( clipper )
add_subdirectory( eckit_readers )

if( metview )
	add_subdirectory( libMagWrapper )
endif()

if( HAVE_ODB )
	add_subdirectory( oda )
endif()

include_directories( ${CMAKE_CURRENT_SOURCE_DIR}/common )

ecbuild_add_library( TARGET    MagPlus
                     DEPENDS   magics_params
                     SOURCES
                        magics.h
                        ${magics_params_srcs}
                        ${common_srcs}
                        ${basic_srcs}
                        ${web_srcs}
                        ${visualisers_srcs}
                        ${eckit_srcs}
                        ${drivers_srcs}
                        ${qt_srcs}
                        ${decoders_srcs}
                        ${clipper_srcs}
                        ${terralib_srcs}
                        ${odb_srcs}
                     TEMPLATES
                        ${common_templates}
                     DEFINITIONS
                        ${MAGICS_EXTRA_DEFINITIONS} MAGICS_EXCEPTION=on
                     LIBS
                        ${MAGICS_EXTRA_LIBRARIES}
                     TYPE SHARED )

ecbuild_add_library( TARGET      MagPlusSingle
                     SOURCES     MagicsSingle.cc
                     LIBS        MagPlus
                     TYPE        SHARED )

ecbuild_add_library( TARGET      MagPlusDouble
                     SOURCES     MagicsDouble.cc
                     LIBS        MagPlus
                     TYPE        SHARED )

if ( BUILD_SHARED_LIBS STREQUAL "BOTH" )
ecbuild_add_library( TARGET    MagPlusStatic
                     DEPENDS   magics_params
                     SOURCES
                        magics.h
                        ${magics_params_srcs}
                        ${common_srcs}
                        ${basic_srcs}
                        ${web_srcs}
                        ${visualisers_srcs}
                        ${eckit_srcs}
                        ${drivers_srcs}
                        ${qt_srcs}
                        ${decoders_srcs}
                        ${clipper_srcs}
                        ${terralib_srcs}
                        ${odb_srcs}
                     TEMPLATES
                        ${common_templates}
                     DEFINITIONS
                        ${MAGICS_EXTRA_DEFINITIONS}
                     LIBS
                        ${MAGICS_EXTRA_LIBRARIES}
                     TYPE STATIC
                     OUTPUT_NAME MagPlus )

ecbuild_add_library( TARGET      MagPlusSingleStatic
                     SOURCES     MagicsSingle.cc
                     LIBS        MagPlusStatic
                     TYPE        STATIC
                     OUTPUT_NAME MagPlusSingle )

ecbuild_add_library( TARGET      MagPlusDoubleStatic
                     SOURCES     MagicsDouble.cc
                     LIBS        MagPlusStatic
                     TYPE        STATIC
                     OUTPUT_NAME MagPlusDouble )

endif()

if( metview )
 include_directories(  ${CMAKE_CURRENT_SOURCE_DIR}
                        ${CMAKE_CURRENT_BINARY_DIR}
                        ${CMAKE_CURRENT_BINARY_DIR}/params
                        ${CMAKE_CURRENT_SOURCE_DIR}/common
                        ${CMAKE_CURRENT_SOURCE_DIR}/basic
                        ${CMAKE_CURRENT_SOURCE_DIR}/web
                        ${CMAKE_CURRENT_SOURCE_DIR}/visualisers
                        ${CMAKE_CURRENT_SOURCE_DIR}/drivers
                        ${CMAKE_CURRENT_SOURCE_DIR}/decoders
                        ${CMAKE_CURRENT_SOURCE_DIR}/clipper
                        ${CMAKE_CURRENT_SOURCE_DIR}/terralib/kernel
                        ${CMAKE_CURRENT_SOURCE_DIR}/libMagWrapper )



  ecbuild_add_library( TARGET    MagWrapper
                     DEPENDS   mv_params magics_params
                     SOURCES
                        magics.h
                        ${metview_srcs}
                        ${metview_wrappers_srcs}
                     DEFINITIONS
                        ${MAGICS_EXTRA_DEFINITIONS}
                    LIBS
                        ${MAGICS_EXTRA_LIBRARIES}
                    TYPE STATIC
                    )
   list( APPEND attributes_include
				OutputHandlerAttributes.h
				FortranRootSceneNodeAttributes.h
                BinningObjectAttributes.h
                GribDecoderAttributes.h
                DateGribLoopStepAttributes.h
                GribLoopAttributes.h
                GeoRectangularProjectionAttributes.h
                LegendVisitorAttributes.h
				XmlRootNodeAttributes.h
				WrepRootNodeAttributes.h
                ContinuousLegendMethodAttributes.h
                HistogramLegendMethodAttributes.h
                XmlBasicNodeAttributes.h
                #ImagePlottingAttributes.h
                LookupTableModeAttributes.h
                FixedTableModeAttributes.h
				)
   if(qt)
     list(APPEND attributes_include
                 QtDriverAttributes.h)
   endif()

   install( FILES terralib/kernel/TeProjection.h
				   terralib/kernel/TeCoord2D.h
				   terralib/kernel/TeDefines.h
				   terralib/kernel/TePrecision.h
				   terralib/kernel/TeSingleton.h
				   terralib/kernel/TeDatum.h
				   terralib/kernel/TeUtils.h


				   DESTINATION ${INSTALL_INCLUDE_DIR})
   install( FILES VectorOfPointers.h  DESTINATION ${INSTALL_INCLUDE_DIR})
   foreach( file ${attributes_include} )
     install( FILES ${CMAKE_CURRENT_BINARY_DIR}/params/${file}  DESTINATION ${INSTALL_INCLUDE_DIR})
   endforeach()
   install( FILES ${metview_include} DESTINATION ${INSTALL_INCLUDE_DIR})
endif()
install( FILES magics.h  DESTINATION ${INSTALL_INCLUDE_DIR})

=== test/CMakeLists.txt ===
set( grib_environment
  GRIB_DEFINITION_PATH=${eccodes_BASE_DIR}/share/${grib_handling_pkg}/definitions
  GRIB_SAMPLES_PATH=${eccodes_BASE_DIR}/share/${grib_handling_pkg}/samples )

# Basic test
ecbuild_add_test( TARGET basic_c
                  SOURCES   coast.c
                  LIBS      MagPlusSingle MagPlus
                  ENVIRONMENT MAGPLUS_HOME=${CMAKE_CURRENT_SOURCE_DIR}/..
                  LINKER_LANGUAGE C )

ecbuild_add_test( TARGET contour_c
                  SOURCES   contour.c
                  LIBS      MagPlusSingle MagPlus
                  ENVIRONMENT MAGPLUS_HOME=${CMAKE_CURRENT_SOURCE_DIR}/..
                              ${grib_environment}
                  LINKER_LANGUAGE C )

ecbuild_add_test( TARGET basic_python
                  TYPE PYTHON
                  CONDITION HAVE_PYTHON
                  ARGS coast.py
                  RESOURCES coast.py
                  ENVIRONMENT PYTHONPATH=${MAG_PYTHON_PATH}
                              LD_LIBRARY_PATH=${CMAKE_BINARY_DIR}/lib
                              DYLD_LIBRARY_PATH=${CMAKE_BINARY_DIR}/lib
                              MAGPLUS_HOME=${CMAKE_CURRENT_SOURCE_DIR}/.. )

ecbuild_add_test( TARGET basic_fortran_shared
                  SOURCES   coast.f90
                  LIBS      MagPlusSingle MagPlus
                  CONDITION HAVE_FORTRAN
                  ENVIRONMENT MAGPLUS_HOME=${CMAKE_CURRENT_SOURCE_DIR}/..
                  LINKER_LANGUAGE Fortran )

ecbuild_add_test( TARGET basic_fortran_static
                  SOURCES   coast.f90
                  LIBS      MagPlusSingleStatic MagPlusStatic ${MAGICS_EXTRA_LIBRARIES}
                  CONDITION HAVE_FORTRAN AND BUILD_SHARED_LIBS STREQUAL "BOTH"
                  ENVIRONMENT MAGPLUS_HOME=${CMAKE_CURRENT_SOURCE_DIR}/..
                  LINKER_LANGUAGE Fortran )

ecbuild_add_test( TARGET bufr_python
                  TYPE PYTHON
                  CONDITION HAVE_BUFR AND HAVE_PYTHON
                  ARGS bufr.py
                  RESOURCES bufr.py synop.bufr
                  ENVIRONMENT PYTHONPATH=${MAG_PYTHON_PATH}
                              LD_LIBRARY_PATH=${CMAKE_BINARY_DIR}/lib
                              DYLD_LIBRARY_PATH=${CMAKE_BINARY_DIR}/lib
                              MAGPLUS_HOME=${CMAKE_CURRENT_SOURCE_DIR}/.. )

ecbuild_add_test( TARGET bufr_fortran
                  SOURCES   bufr.f90
                  LIBS      MagPlusSingle MagPlus
                  CONDITION HAVE_BUFR AND HAVE_FORTRAN
                  RESOURCES synop.bufr
                  LINKER_LANGUAGE Fortran
                  ENVIRONMENT MAGPLUS_HOME=${CMAKE_CURRENT_SOURCE_DIR}/..
                              ${grib_environment})

ecbuild_add_test( TARGET bufr_fortran_static
                  SOURCES   bufr.f90
                  RESOURCES synop.bufr
                  LIBS      MagPlusSingleStatic MagPlusStatic
                  CONDITION HAVE_BUFR AND HAVE_FORTRAN AND BUILD_SHARED_LIBS STREQUAL "BOTH"
                  ENVIRONMENT MAGPLUS_HOME=${CMAKE_CURRENT_SOURCE_DIR}/..
                  LINKER_LANGUAGE Fortran )

ecbuild_add_test( TARGET grib_python
                  TYPE PYTHON
                  CONDITION HAVE_CAIRO AND HAVE_GRIB AND HAVE_PYTHON
                  ARGS grib.py
                  RESOURCES grib.py data.grib
                  ENVIRONMENT PYTHONPATH=${MAG_PYTHON_PATH}
                              LD_LIBRARY_PATH=${CMAKE_BINARY_DIR}/lib
                              DYLD_LIBRARY_PATH=${CMAKE_BINARY_DIR}/lib
                              MAGPLUS_HOME=${CMAKE_CURRENT_SOURCE_DIR}/..
                              ${grib_environment} )

ecbuild_add_test( TARGET grib_fortran
                  SOURCES   grib.f90
                  LIBS      MagPlusSingle MagPlus
                  RESOURCES data.grib
                  CONDITION HAVE_GRIB AND HAVE_FORTRAN
                  ENVIRONMENT MAGPLUS_HOME=${CMAKE_CURRENT_SOURCE_DIR}/..
                  ${grib_environment}
                  LINKER_LANGUAGE Fortran
                  )

ecbuild_add_test( TARGET netcdf_contour_python
                  TYPE PYTHON
                  CONDITION HAVE_NETCDF AND HAVE_PYTHON
                  ARGS netcdf_contour_python.py
                  RESOURCES netcdf_contour_python.py era5_2mt.nc
                  ENVIRONMENT PYTHONPATH=${MAG_PYTHON_PATH}
                              LD_LIBRARY_PATH=${CMAKE_BINARY_DIR}/lib
                              DYLD_LIBRARY_PATH=${CMAKE_BINARY_DIR}/lib
                              MAGPLUS_HOME=${CMAKE_CURRENT_SOURCE_DIR}/.. )

ecbuild_add_test( TARGET cairo_python
                  TYPE PYTHON
                  CONDITION HAVE_CAIRO AND HAVE_PYTHON
                  ARGS cairo.py
                  RESOURCES cairo.py
                  ENVIRONMENT PYTHONPATH=${MAG_PYTHON_PATH}
                              LD_LIBRARY_PATH=${CMAKE_BINARY_DIR}/lib
                              DYLD_LIBRARY_PATH=${CMAKE_BINARY_DIR}/lib
                              MAGPLUS_HOME=${CMAKE_CURRENT_SOURCE_DIR}/.. )

ecbuild_add_test( TARGET cairo_fortran
                  SOURCES   cairo.f90
                  LIBS      MagPlusSingle MagPlus
                  CONDITION HAVE_CAIRO AND HAVE_FORTRAN
                  ENVIRONMENT MAGPLUS_HOME=${CMAKE_CURRENT_SOURCE_DIR}/..
                  LINKER_LANGUAGE Fortran )

ecbuild_add_test( TARGET odb_python
                  TYPE PYTHON
                  CONDITION HAVE_CAIRO AND HAVE_ODB AND HAVE_PYTHON
                  ARGS odb.py
                  RESOURCES odb.py test.odb
                  ENVIRONMENT PYTHONPATH=${MAG_PYTHON_PATH}
                              LD_LIBRARY_PATH=${CMAKE_BINARY_DIR}/lib
                              DYLD_LIBRARY_PATH=${CMAKE_BINARY_DIR}/lib
                              MAGPLUS_HOME=${CMAKE_CURRENT_SOURCE_DIR}/.. )

=== src/common/CMakeLists.txt ===
list( APPEND _common_srcs

	OutputFactory.h MagLog.h
	BaseParameter.h Colour.h MagException.h
	Factory.cc Factory.h
	ParameterManager.h Frame.h Layout.h
	PaperPoint.h GeoPoint.h  Tokenizer.h Node.h MagTranslator.h
	ImageProperties.h LogoPlotting.h
	ImportObject.h ColourTable.h PageID.h
	Transformation.h Dimension.h
	XmlNode.h XmlTree.h XmlReader.h BackgroundColour.h
	ColourTableDefinition.h ColourTableDefinitionCompute.h ColourTableDefinitionComputeInterface.h
	ColourTableDefinitionList.h ColourTableDefinitionListInterface.h 
	TableDefinition.h TableDefinitionList.h TableDefinitionListInterface.h
	TableDefinitionCompute.h TableDefinitionComputeInterface.h
	HeightTableDefinition.h LevelTableDefinition.h IntervalMap.h PaperDimension.h
	Matrix.h MatrixHandler.h Data.h Decoder.h
	BasePointsHandler.h RasterData.h  Visualiser.h CustomisedPoint.h PointsHandler.h
	MetaData.h
	Polyline.h
	Text.h
	Symbol.h
	BinaryObject.h
	Arrow.h
	Flag.h
	Image.h 
	ArrowProperties.h
	MagicsParameter.cc MagicsParameter.h Clipper.h LogoPlottingBase.h
	TableDefinitionCompute.cc 
	TableDefinitionList.cc
	Coordinate.h OutputHandler.h
	MagFont.h 
	AnimationRules.h SymbolItem.h
	UserPoint.h Label.h
	Timer.h
	CustomisedPoint.h Static.h DriverStatic.h ProgressObject.h PolyCoast.h
	ProgressTask.h FullPaperPoint.h
	BasePointsHandler.h PointsHandler.h Decoder.h Data.h
	Visualiser.h MatrixHandler.h
	Seconds.h
	Matrix.h Matrix.cc
	Path.h
	MagicsSingleton.h
	PlotManager.h
	Image.h 
	MagClipper.h
	XmlReader.h XmlTree.h XmlNode.h
	MagicsFormat.h
	CartesianTransformation.h
	Dimension.cc
	XCoordinate.h YCoordinate.h marsmachine.h linux.h aix.h
	Thread.h MutexCond.h Mutex.h AutoLock.h ThreadControler.h Task.h MagExceptions.h ThreadSingleton.h 
    DataStats.h SciMethods.h Tephigram.cc  Tephigram.h Skewt.cc  Skewt.h Emagram.cc Emagram.h

# sources
	Data.cc Matrix.cc MagicsCalls.cc Static.cc DriverStatic.cc MagLog.cc Colour.cc Transformation.cc MagException.cc
	BaseParameter.cc ParameterManager.cc  
	Tokenizer.cc Timer.cc Seconds.cc Label.cc MagClipper.cc
	ArrowProperties.cc
	XmlReader.cc XmlTree.cc XmlNode.cc Dimension.cc
	MetaData.cc
	MagicsFormat.cc
	OutputHandler.cc  OutputFactory.cc
	MagFont.cc
	ColourTable.cc ColourTableDefinitionList.cc
	ColourTableDefinitionCompute.cc CartesianTransformation.cc
	BinaryObject.cc
	Coordinate.cc
	LogoPlotting.cc
	PageID.cc AnimationRules.cc Layout.cc SymbolItem.cc Symbol.cc Polyline.cc
	Text.cc Flag.cc  
	Mutex.cc MutexCond.cc Thread.cc MagExceptions.cc AutoLocker.cc
	ThreadControler.cc Task.cc
	DataStats.cc SciMethods.cc BasePointsHandler.cc PointsHandler.cc ProgressObject.cc

# projection
    GeoRectangularProjection.cc  PolarStereographicProjection.cc TaylorProjection.cc
    GeoRectangularProjection.h   PolarStereographicProjection.h TaylorProjection.h
    Proj4Projection.cc  Proj4Projection.h

# unused


 )


list( APPEND _common_templates 
    Factory.cc 
    MagicsParameter.cc
    TableDefinitionList.cc
    TableDefinitionCompute.cc
 )

foreach( file ${_common_srcs} )
  list( APPEND common_srcs common/${file} )
endforeach()
foreach( file ${_common_templates} )
  list( APPEND common_templates common/${file} )
endforeach()

set( common_srcs ${common_srcs} PARENT_SCOPE )
set( common_templates ${common_templates} PARENT_SCOPE )

if ( metview )
	list (APPEND metview_include 
				common/MagLog.h 
				common/MagTranslator.h 
				common/Factory.h 
				common/Factory.cc 
				common/Colour.h 
				common/Tokenizer.h 
				common/MagException.h 
				common/ParameterManager.h
				common/PaperPoint.h 
				common/Matrix.h
				common/BaseParameter.h
				common/OutputHandler.h
				common/OutputFactory.h
				common/Layout.h
				common/XmlNode.h 
				common/Transformation.h
				common/UserPoint.h
				common/CustomisedPoint.h
				common/XmlTree.h
				common/XmlReader.h
				common/RasterData.h
				common/Decoder.h
				common/Data.h
				common/MatrixHandler.h
				common/BasePointsHandler.h
				common/Timer.h
                common/DataStats.h
                common/IntervalMap.h
                common/GeoRectangularProjection.h
                common/Text.h
                common/Label.h
                common/MagFont.h
                common/Image.h
                common/ImageProperties.h
                common/ColourTable.h
                common/ColourTableDefinition.h
                common/PointsHandler.h
				)
	set( metview_include ${metview_include} PARENT_SCOPE )
endif()
install ( FILES magics_api.h  DESTINATION ${INSTALL_INCLUDE_DIR})

=== src/params/CMakeLists.txt ===
list( APPEND _common_xmls
MagicsGlobal.xml
Akima474Method.xml
Akima760Method.xml
ArrowPlotting.xml
AutomaticContourMethod.xml
Axis.xml
AxisMethod.xml
Bar.xml
BaseDriver.xml
BinaryDriver.xml
BinaryObject.xml
BinningObject.xml
BothValuePlotMethod.xml
Boundaries.xml
CalculateColourTechnique.xml
GradientsColourTechnique.xml
PaletteColourTechnique.xml
CalculateHeightTechnique.xml
CalmIndicator.xml
CartesianTransformation.xml
CellShading.xml
CircleOriginMarker.xml
Cities.xml
ClassicMtgDecoder.xml
CoastPlotting.xml
Coastlines.xml
ColourTechnique.xml
ContinuousLegendMethod.xml
Contour.xml
ContourLibrary.xml
ContourMethod.xml
CountSelectionType.xml
Curve.xml
CurveArea.xml
DateAxisMethod.xml
DateGribLoopStep.xml
DotGraphShadeStyle.xml
DotOriginMarker.xml
DotPolyShadingMethod.xml
DumpShading.xml
Emagram.xml
EmagramGrid.xml
FlagPlotting.xml
FortranRootSceneNode.xml
FortranSceneNode.xml
FortranViewNode.xml
GeoPointsDecoder.xml
GeoRectangularProjection.xml
Graph.xml
GraphArrow.xml
GraphFlag.xml
GraphPlotting.xml
GraphShade.xml
GraphShadeStyle.xml
GridPlotting.xml
GridShading.xml
HatchGraphShadeStyle.xml
HatchPolyShadingMethod.xml
HeightTechnique.xml
HiLo.xml
HiLoBase.xml
HiLoBoth.xml
HiLoMarker.xml
HiLoMarkerBase.xml
HiLoNumber.xml
HiLoTechnique.xml
HiLoText.xml
HighHiLo.xml
Histogram.xml
HistogramLegendMethod.xml
HyperAxisMethod.xml
ImportAction.xml
ImportPlot.xml
InputData.xml
LogoPlotting.xml
NoLogoPlotting.xml
IntervalSelectionType.xml
IsoHighlight.xml
IsoLabel.xml
IsoPlot.xml
IsoShading.xml
KMLDriver.xml
GeoJsonDriver.xml
LabelPlotting.xml
ObsPlotting.xml
LegendMethod.xml
LegendVisitor.xml
LevelListSelectionType.xml
LevelSelection.xml
ListColourTechnique.xml
ListHeightTechnique.xml
LogarithmicAxisMethod.xml
LookupTableMode.xml
LowHiLo.xml
MagnifierVisitor.xml
MapGenDecoder.xml
MarkerShadingTechnique.xml
MarkerValuePlotMethod.xml
MercatorProjection.xml
MetaData.xml
MvRootSceneNode.xml
NoBinningObject.xml
NoBoundaries.xml
NoCalmIndicator.xml
NoCities.xml
NoCoastPlotting.xml
NoGraphShade.xml
NoGridPlotting.xml
NoHiLo.xml
NoHiLoMarker.xml
NoIsoHighlight.xml
NoIsoLabel.xml
NoIsoPlot.xml
NoIsoShading.xml
NoLabelPlotting.xml
#NoLegendVisitor.xml
NoLogoPlotting.xml
NoMagnifierVisitor.xml
NoOriginMarker.xml
NoOutLayerTechnique.xml
NoPageID.xml
NoPreviewVisitor.xml
NoValuePlot.xml
OriginMarker.xml
OutputHandler.xml
PageID.xml
ParamGribLoopStep.xml
PolarStereographicProjection.xml
PolyShadingMethod.xml
PolyShadingTechnique.xml
PositionListAxisMethod.xml
PostScriptDriver.xml
PreviewVisitor.xml
Proj4Bonne.xml
Proj4PolarSouth.xml
Proj4Mercator.xml
Proj4Collignon.xml
Proj4Automatic.xml
Proj4EPSG32661.xml
Proj4EPSG4326.xml
Proj4EPSG3857.xml
Proj4EPSG900913.xml
Proj4Geos.xml
Proj4Goode.xml
Proj4Lambert.xml
Proj4Mollweide.xml
Proj4PolarNorth.xml
Proj4Projection.xml
Proj4Robinson.xml
Proj4Google.xml
Proj4Efas.xml
Proj4TPers.xml
Proj4LambertNorthAtlantic.xml
Proj4Meteosat0.xml
Proj4Meteosat145.xml
Proj4Meteosat57.xml
Proj4Geosw.xml
Proj4Geose.xml
SDWindMode.xml
SVGDriver.xml
ImportObjectHandler.xml
SelectionMode.xml
ShadingTechnique.xml
ShapeDecoder.xml
SimpleOutLayerTechnique.xml
Skewt.xml
SkewtGrid.xml
SymbolAdvancedTableMode.xml
SymbolIndividualMode.xml
SymbolInput.xml
SymbolMode.xml
SymbolPlotting.xml
SymbolTableMode.xml
Streamlines.xml
TableDecoder.xml
TaylorGrid.xml
TaylorProjection.xml
TextVisitor.xml
Tephigram.xml
TephiGrid.xml
TitleTemplate.xml
Transformation.xml
UVWindMode.xml
UserLogoPlotting.xml
VDWindMode.xml
ValuePlot.xml
ValuePlotBase.xml
ValuePlotMethod.xml
Wind.xml
WindMode.xml
WindPlotting.xml
ObsDecoder.xml
XCoordinate.xml
XDateCoordinate.xml
XHyperCoordinate.xml
XLogarithmicCoordinate.xml
XRegularCoordinate.xml
XYList.xml
GeoJSon.xml
YCoordinate.xml
YDateCoordinate.xml
YHyperCoordinate.xml
YLogarithmicCoordinate.xml
YRegularCoordinate.xml
)

list( APPEND _magics_xmls BoxPlotBox.xml
		BoxPlotBoxBorder.xml
		BoxPlotDecoder.xml
		BoxPlotMedian.xml
		BoxPlotVisualiser.xml
		BoxPlotWhiskerBorder.xml
		BoxPlotWhiskerBox.xml
		BoxPlotWhiskerLine.xml
		CdfGraph.xml
		EpsCloud.xml
		EpsDirection.xml
		EpsGraph.xml
		EpsPlume.xml
		EpsShade.xml
		EpsWave.xml
		EpsWind.xml
		CapeBox.xml
		EpsXmlInput.xml
		EpsgramDecoder.xml
		EquidistantTableMode.xml
		FixedTableMode.xml
		EfiDataDecoder.xml
		EfiGraph.xml
		EfiJSon.xml
		EfigramDecoder.xml
		EpsBufr.xml
		ImageCalculateColourTechnique.xml
		ImageListColourTechnique.xml
		#ImagePlotting.xml
		InputMatrix.xml
		InputMatrixIrregularInterpretor.xml
		InputMatrixRegularInterpretor.xml
		LandgramBox.xml
		LandgramDecoder.xml
		MetgramCurve.xml
		MetgramFlags.xml
		MetgramGraph.xml
		MetgramBar.xml
		ObsTable.xml
		ObsJSon.xml
		ObsStatDecoder.xml
		SimplePolyline.xml
		SimplePolylineInput.xml
		WrepJSon.xml
		WrepRootNode.xml
		XmlBasicNode.xml
		XmlRootNode.xml
		XmlSceneNode.xml
		XmlViewNode.xml
)


if( HAVE_GRIB )
	list( APPEND _common_xmls GribAddressByteMode.xml
		GribAddressMode.xml
		GribAddressRecordMode.xml
		GribLoop.xml
		GribLoopStep.xml
		GribDecoder.xml
		)
endif()

if( HAVE_NETCDF )
	list( APPEND _common_xmls
		NetcdfDecoder.xml
		NetcdfInterpretor.xml
		NetcdfXYpointsInterpretor.xml
		NetcdfOrcaInterpretor.xml
		NetcdfGeopointsInterpretor.xml
		NetcdfGeoPolarMatrixInterpretor.xml
		NetcdfGeoVectorInterpretor.xml
		NetcdfGuessInterpretor.xml
		NetcdfVectorInterpretor.xml
		NetcdfGeoMatrixInterpretor.xml
		NetcdfMatrixInterpretor.xml
		)
endif()

if ( HAVE_ODB )
	list ( APPEND _common_xmls
		OdaGeoDecoder.xml
		OdaXYDecoder.xml )
endif()

if( HAVE_CAIRO )
    list( APPEND _common_xmls CairoDriver.xml )
endif()

if( MAGICS_RASTER )
  list( APPEND _common_xmls GDDriver.xml )
endif()

if( MAGICS_QT )
  list( APPEND  _magics_xmls QtDriver.xml )
endif()

foreach( file ${_common_xmls} )
  list( APPEND metview_xmls params/${file} )
  list( APPEND magics_xmls params/${file} )
endforeach()

foreach( file ${_magics_xmls} )
  list( APPEND magics_xmls params/${file} )
endforeach()


set( magics_xmls ${magics_xmls} PARENT_SCOPE )

if( metview )
  set( metview_xmls ${metview_xmls} PARENT_SCOPE )
  add_metview_definition_file(FILE ImportObjectHandler.xml  BASENAME MIMPORT   ACTION MIMPORT)
  add_metview_definition_file(FILE Contour.xml         BASENAME MCONT   ACTION MCONT)
  add_metview_definition_file(FILE SymbolPlotting.xml  BASENAME MSYMB ACTION   MSYMB)
  add_metview_definition_file(FILE Coastlines.xml      BASENAME MCOAST  ACTION MCOAST)
  add_metview_definition_file(FILE LegendVisitor.xml   BASENAME MLEGEND ACTION MLEGEND)
  add_metview_definition_file(FILE Wind.xml            BASENAME MWIND   ACTION MWIND)
  add_metview_definition_file(FILE GraphPlotting.xml   BASENAME MGRAPH  ACTION MGRAPH)
  add_metview_definition_file(FILE TextVisitor.xml     BASENAME MTEXT   ACTION MTEXT)
  add_metview_definition_file(FILE Axis.xml            BASENAME MAXIS   ACTION MAXIS)
  add_metview_definition_file(FILE BinningObject.xml   BASENAME BinningObject  ACTION MBINNING)
  add_metview_definition_file(FILE TephiGrid.xml       BASENAME MTHERMOGRID  ACTION MTHERMOGRID)
  add_metview_definition_file(FILE ObsPlotting.xml     BASENAME ObsPlotting  ACTION MOBS)
endif( metview )

=== debian/changelog ===
magics++ (3.3.1-1+rb2) UNRELEASED; urgency=medium

  * update

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 22 Jan 2021 11:55:15 +0800

magics++ (3.3.1-1) unstable; urgency=medium

  * New upstream release
  * Sanitize build path for magics*cmake scripts in -dev pkg

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 20 Dec 2018 10:09:33 +0000

magics++ (3.2.1-2) unstable; urgency=medium

  * Team upload
  * Fixup VCS fields
  * Add python3:Depends to -dev package, and runtime python development
    packages:
    - cmake files are currently needing python libraries

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 06 Nov 2018 14:45:44 +0100

=== debian/control ===
Source: magics++
Section: science
Priority: optional
Maintainer: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper  (>= 10) , 
 dh-buildinfo, 
 gfortran, 
 cmake (>= 3.1), 
 chrpath,
 dh-python,  swig,
 python-dev, python-numpy, 
 python3-all-dev, python3-numpy,
 python-jinja2,
 python3-jinja2,
 libhdf5-dev | libhdf5-mpi-dev, 
 libnetcdf-dev, libnetcdf-cxx-legacy-dev,
 libgl1-mesa-dev, libgd-dev, 
 libemos-dev (>=  2:4.3.9), libgeotiff-dev,
 libodb-api-dev (>= 0.17.4-3),
 libeccodes-dev (>= 2.9.2-3),
 libeccodes-tools,
 libemos-bin, 
 libopenjp2-7-dev,
 libaec-dev,
 libterralib-dev, 
 libcairo2-dev, 
 libpango1.0-dev,
 ttf-dejavu-core, 
 libxml-parser-perl, 
 ghostscript, 
 zlib1g-dev, 
 libboost-dev | libboost1.63-dev, 
 libproj-dev, 
 qtbase5-dev-tools, 
 qtbase5-dev, 
 qt5-qmake
Standards-Version: 4.2.1
Homepage: https://software.ecmwf.int/wiki/display/MAGP/Magics
Vcs-Browser: https://salsa.debian.org/science-team/magics.git
Vcs-Git: https://salsa.debian.org/science-team/magics.git

Package: libmagplus3v5
Section: libs
Architecture: any
Multi-Arch: same
Depends: libmagics++-data,${misc:Depends}, ${shlibs:Depends}, ttf-dejavu-core, ttf-dejavu-extra, ghostscript
Description: ECMWF meteorological plotting software library
 Magics++ is the latest generation of the ECMWF's Meteorological plotting
 software MAGICS. Although completely redesigned in C++, it is intended to be
 as backwards-compatible as possible with the Fortran interface.
 Besides its programming interfaces (Fortran and C), Magics++ offers MagML,
 a plot description language based on XML aimed at automatic web production.
 .
 The library supports the plotting of contours, wind fields, observations,
 satellite images, symbols, text, axis and graphs (including boxplots).
 .
 Data fields to be plotted may be presented in various formats,
 for instance GRIB 1 and 2 code data, Gaussian grid, regularly spaced grid
 and fitted data. Input data can also be in BUFR and NetCDF format
 or retrieved from an ODB database.
 .
 The produced meteorological plots can be saved in various formats,
 such as PostScript, EPS, PDF, GIF, PNG, SVG and KML.

Package: libmagics++-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libmagplus3v5 ( = ${binary:Version} ), ${misc:Depends}, ${python:Depends}, ${python3:Depends},
 libterralib-dev, magics++, libodb-api-dev, python-all-dev, python3-all-dev
Recommends: pkg-config
Description: Development files for ECMWF  plotting software MAGICS++
 Magics++ is the latest generation of the ECMWF's Meteorological plotting
 software MAGICS. Although completely redesigned in C++, it is intended to be
 as backwards-compatible as possible with the Fortran interface.
 Besides its programming interfaces (Fortran and C), Magics++ offers MagML,
 a plot description language based on XML aimed at automatic web production.
 .
 This package includes the header files and static libraries needed to build 
 against libmagics++.

Package: magics++
Architecture: any
Multi-Arch: foreign
Depends: libmagplus3v5 ( = ${binary:Version} ),
 ${misc:Depends}, ${shlibs:Depends}, ${python:Depends}
Description: Executables for the magics++ library
 Magics++ is the latest generation of the ECMWF's Meteorological plotting
 software MAGICS. Although completely redesigned in C++, it is intended to be
 as backwards-compatible as possible with the Fortran interface.
 Besides its programming interfaces (Fortran and C), Magics++ offers MagML,
 a plot description language based on XML aimed at automatic web production.
 .
 This package contains the MagcML binary that may be used with magics++.

Package: python-magics++
Section: python
Architecture: any
Depends:  libmagplus3v5 ( = ${binary:Version} ), ${misc:Depends}, ${shlibs:Depends}, ${python:Depends}, 
 python, python-simplejson, python-jinja2
Description: python support for Magics++
 Magics++ is the latest generation of the ECMWF's Meteorological plotting
 software MAGICS. Although completely redesigned in C++, it is intended to be
 as backwards-compatible as possible with the Fortran interface.
 .
 This package provides python support for the magics++ library.

Package: python3-magics++
Section: python
Architecture: any
Depends:  libmagplus3v5 ( = ${binary:Version} ), ${misc:Depends}, ${shlibs:Depends}, ${python3:Depends}, 
 python3-simplejson, python3-jinja2
Description: Python3 support for Magics++
 Magics++ is the latest generation of the ECMWF's Meteorological plotting
 software MAGICS. Although completely redesigned in C++, it is intended to be
 as backwards-compatible as possible with the Fortran interface.
 .
 This package provides Python3 support for the magics++ library.

Package: libmagics++-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Data files needed for magics++ library
 Magics++ is the latest generation of the ECMWF's Meteorological plotting
 software MAGICS. Although completely redesigned in C++, it is intended to be
 as backwards-compatible as possible with the Fortran interface.
 .
 This package contains data expected by the magics++ library.


Package: libmagics++-metview-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, libmagplus3v5 ( = ${binary:Version} )
Description: Libraries needed for building MetView
 Magics++ is the latest generation of the ECMWF's Meteorological plotting
 software MAGICS. Although completely redesigned in C++, it is intended to be
 as backwards-compatible as possible with the Fortran interface.
 .
 This package includes the header files and static libraries needed to build
 metview against magics++.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1

# To enable all, uncomment following line
# DEB_BUILD_MAINT_OPTIONS:= hardening=+all,-pie
CXXFLAGS:= -fPIC $(shell dpkg-buildflags --get CXXFLAGS) # -std=c++14
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

# Set for build reproducibility
LC_ALL=C
export LC_ALL

export QT_SELECT=5

LIBDIR=/usr/lib/$(DEB_HOST_MULTIARCH)
AUTOGENERATED:= libmagplus3v5.links libmagics++-dev.links libmagplus3v5.install
# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

%:
	dh $@ --with python2,python3 --with-buildsystem=cmake

# To fix cmake output change these
OLD_GF_PATH=$(shell gfortran -print-search-dirs | grep install | cut -f2 -d' '  )libgfortran.so
NEW_GF_PATH:=$(LIBDIR)/libgfortran.so.4

# -DCMAKE_PREFIX_PATH=${LIBDIR}/cmake/grib_api \

export extra_flags +=  \
	-DBUILD_SITE=debian \
	-DENABLE_LIBGD=1 \
	-DHAVE_BOOST=1 \
	-DENABLE_ODB=1 \
	-DHAVE_DLFCN_H=1 \
	-DHAVE_INTTYPES_H=1 \
	-DHAVE_LIBEXPAT=1 \
	-DHAVE_LIBPROJ=1 \
	-DHAVE_LIBPTHREAD=1 \
	-DHAVE_LIBZ=1 \
	-DHAVE_MEMORY_H=1 \
	-DHAVE_STDINT_H=1 \
	-DHAVE_STDLIB_H=1 \
	-DHAVE_STRINGS_H=1 \
	-DHAVE_STRING_H=1 \
	-DHAVE_SYS_STAT_H=1 \
	-DHAVE_STS_TYPES_H=1 \
	-DHAVE_UNISTD_H=1 \
	-DMAGICS_ALLHEADERS=1 \
	-DMAGICS_GRIB=1 \
	-DMAGICS_JSON=1 \
	-DMAGICS_METVIEW=1 \
	-DMAGICS_GIF=1 \
	-DMAGICS_GIF_ANIMATED=1 \
	-DMAGICS_TIFF=1 \
	-DMAGICS_TTF=1 \
	-DMAGICS_TTF_PATH="share/magics/ttf/" \
	-DMAGICS_SITE="debian" \
	-DMAGICS_PYTHON=1 \
	-DMAGICS_THREADS=1 \
	-DDISABLE_OS_CHECK=ON \
	-DCMAKE_INSTALL_PREFIX=/usr \
	-DCMAKE_VERBOSE_MAKEFILE=ON \
	-DBUILD_DOCUMENTATION=ON \
	-DENABLE_FORTRAN=ON \
	-DENABLE_LARGE_FILE_SUPPORT=ON \
	-DENABLE_PYTHON=ON \
	-DBUILD_EXAMPLES=ON \
	-DBUILD_SHARED_LIBS=ON \
	-DENABLE_TESTS=ON \
	-DENABLE_GEOTIFF=ON \
	-DGEOTIFF_INCLUDE_DIR=/usr/include/geotiff \
	-Dodb_api_DIR=${LIBDIR}/cmake/odb_api \
	-DENABLE_RPATHS=OFF \
	-DENABLE_CAIRO=ON \
	-DENABLE_BUFR=ON \
	-DENABLE_GRIB=ON \
	-DENABLE_METVIEW=ON \
	-DENABLE_QT5=ON \
	-DENABLE_NETCDF=ON \
	-DCMAKE_CXX_FLAGS='$(CXXFLAGS) -I/usr/include/terralib -I/usr/include/terralib/kernel' \
	-DMAGICS_EXTRA_LIBRARIES='-lterralib -lgd -lemosR64' 

export LD_LIBRARY_PATH:=$(CURDIR)/debian/tmp/usr/lib:$(LD_LIBRARY_PATH)

override_dh_auto_clean:
	rm -rf debian/build-py* build/*x
	rm -f bin/magjsonx  bin/magmlx  bin/metgramx
	find . -type l -delete
	rm -f src/params/*.h src/decoders/*Attributes.h
	rm -rf share/magics/ttf src/terralib debian/build src/boost
	rm -f $(patsubst %, debian/%, ${AUTOGENERATED})

override_dh_auto_configure:
	# link for font for tesing.
	mkdir -p share/fonts/truetype/ttf-dejavu/
	ln -sf /usr/share/fonts/truetype/ttf-dejavu/DejaVuSans.ttf share/fonts/truetype/ttf-dejavu/
	# Link terralib
	[ -e src/terralib ] || ln -sf  /usr/include/terralib src/terralib
	for f in ${AUTOGENERATED} ; do \
                sed -e 's%@ARCH@%${DEB_HOST_MULTIARCH}%g' < debian/$$f.in  > debian/$$f ; \
                done
	dh_auto_configure --builddirectory=debian/build-py3 -- \
		-DPYTHON_EXECUTABLE=/usr/bin/python3 \
	       	$(extra_flags) 
	dh_auto_configure --builddirectory=debian/build-py2 -- \
		-DPYTHON_EXECUTABLE=/usr/bin/python \
	       	$(extra_flags) 
	(cd python/Magics && ln -s $(CURDIR)/debian/build-py3/python/Magics/Magics.i )

override_dh_auto_build:
	dh_auto_build  --builddirectory=debian/build-py2
	dh_auto_build  --builddirectory=debian/build-py3

override_dh_auto_test check:
	# echo "Tests disabled; see README-testfailures.txt for details"
	# (ulimit -s 8192; export PYTHONPATH=$(CURDIR)/debian/build-py2/python/Magics ; \
	#	export MAGPLUS_HOME=$(CURDIR) ; $(MAKE) -C debian/build-py2  check )
	#(ulimit -s 8192; export PYTHONPATH=$(CURDIR)/debian/build-py3/python/Magics ; \
	#	export MAGPLUS_HOME=$(CURDIR) ; $(MAKE) -C debian/build-py3  check )

override_dh_auto_install:
	(cd  debian/build-py2/python && python2 ./setup.py install --prefix=$(CURDIR)/debian/tmp/usr )
	(cd  debian/build-py3/python && python3 ./setup.py install --prefix=$(CURDIR)/debian/tmp/usr )
	dh_auto_install --builddirectory=debian/build-py3
	# Move lib stuff
	mkdir -p debian/tmp/$(LIBDIR)
	cp -a debian/tmp/usr/lib/*.a debian/tmp/usr/lib/pkgconfig debian/tmp/$(LIBDIR)
	cp debian/tmp/usr/lib/libMagPlus.so debian/tmp/$(LIBDIR)/libMagPlus.so.3.0.0
	# Fixup the cmake files.
	mkdir -p debian/tmp/$(LIBDIR)/cmake/magics
	cp -a debian/tmp/usr/share/magics/cmake/* debian/tmp/$(LIBDIR)/cmake/magics
	sed -e 's%$${_IMPORT_PREFIX}/lib%$(LIBDIR)%' \
		< debian/tmp/usr/share/magics/cmake/magics-targets-none.cmake \
	| sed -e 's%$${_IMPORT_PREFIX}/bin%/usr/bin%' \
	| sed -e 's%$(OLD_GF_PATH)%$(NEW_GF_PATH)%'   \
		> debian/tmp/$(LIBDIR)/cmake/magics/magics-targets-none.cmake
	sed -e 's%$${CURDIR}%/build/magics++%g' \
		< debian/tmp/usr/share/magics/cmake/magics-config.cmake \
		> debian/tmp/$(LIBDIR)/cmake/magics/magics-config.cmake
	sed -e 's%$${CURDIR}%/build/magics++%g' \
		< debian/tmp/usr/share/magics/cmake/magics-import.cmake \
		> debian/tmp/$(LIBDIR)/cmake/magics/magics-import.cmake
	rm -r debian/tmp/usr/share/magics/cmake
	dh_python2 /usr/lib/python2.7/site-packages/Magics
	dh_python3 /usr/lib/python3*/site-packages/Magics
	dh_numpy -p python-magics++
	dh_numpy3 -p python3-magics++
	-find debian/tmp/usr/bin -type f  -exec chrpath -d {} \;
	-find debian/tmp debian/libmagplus3v5   -name '*.so*' -exec chrpath -d {} \;

override_dh_makeshlibs:
	# For new symbols when compiled with GCC 7
	dh_makeshlibs -V'libmagplus3v5 (>= 2.34.1-2~)'

override_dh_fixperms-arch:
	dh_fixperms
	find debian/tmp debian/python*-magics++   -name '*.so*' -exec chrpath -d {} \;
